package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.SysAdminFunc;
import com.sa.ibiz.demo.demo.service.SysAdminFuncService;
import com.sa.ibiz.demo.demo.service.dto.SysAdminFuncSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/sysadminfunc")
public class SysAdminFuncResource
{
	@Autowired
	private SysAdminFuncService service;


	@PostMapping(value = "/update")
	public ResponseEntity<SysAdminFunc> update(@Validated @RequestBody SysAdminFunc data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("系统管理功能[update]操作发生错误","SysAdminFunc",data.getSysadminfuncid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<SysAdminFunc> create(@Validated @RequestBody SysAdminFunc data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("系统管理功能[create]操作发生错误","SysAdminFunc",data.getSysadminfuncid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<SysAdminFunc> get(@Validated @PathVariable String id){
		SysAdminFunc data=new SysAdminFunc();
		data.setSysadminfuncid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("系统管理功能[get]操作发生错误","SysAdminFunc",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<SysAdminFunc> remove(@Validated @RequestBody SysAdminFunc data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("系统管理功能[remove]操作发生错误","SysAdminFunc",data.getSysadminfuncid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<SysAdminFunc> getDraft(@Validated @RequestBody SysAdminFunc data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("系统管理功能[getDraft]操作发生错误","SysAdminFunc","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<SysAdminFunc> checkKey(@Validated @RequestBody SysAdminFunc data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("系统管理功能[checkKey]操作发生错误","SysAdminFunc",data.getSysadminfuncid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<SysAdminFunc>> searchDefaultPage(@Validated @RequestBody SysAdminFuncSearchFilter filter){
		Page<SysAdminFunc> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<SysAdminFunc>> listDefault(@Validated @RequestBody SysAdminFuncSearchFilter filter){
		List<SysAdminFunc> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
